package org.jboss.devconf;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;

import org.jbpm.api.Configuration;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.ProcessInstance;

public class StartProcess {

	private static final String PROCESS_ID_FILE = "procid.txt";  
		
	public static void main(String[] args) {

		Configuration jbpmConfiguration = new Configuration();

		ProcessEngine engine = jbpmConfiguration.buildProcessEngine();

		Map<String, Object> processVars = new HashMap<String, Object>();
		Order order = new Order("ACME", "hammer", 10, 50);
		processVars.put("order", order);
		ProcessInstance process = engine.getExecutionService()
				.startProcessInstanceByKey("OrderProcess", processVars);
		System.out.println("Executing process id=" + process.getId());
		writeProcessId(process.getId());
	}

	public static final void writeProcessId(String processId) {
		try {
			PrintWriter pw = new PrintWriter(new FileWriter(PROCESS_ID_FILE));
			pw.println(processId);
			pw.close();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static final String readProcessId() {
		try {
			LineNumberReader r = new LineNumberReader(new FileReader(PROCESS_ID_FILE));
			String id = r.readLine();
			r.close();
			System.out.println("Retrieveing process id=" + id);
			return id;
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
}
